import roboidai as ai
from roboid import *

hamster = HamsterS()

cam = ai.Camera('usb0', flip='h')
dt = ai.AgeGenderDetector()

dt.download_age_model()
dt.load_age_model()

def control():
    prev_angle = 0
    while True:
        angle = dt.get_age_index() * 45 + 22.5
        hamster.turn_left(angle - prev_angle)
        prev_angle = angle
        wait(20)

cam.count_down(3)
parallel(control)

while True:
    image = cam.read()
    if dt.detect(image):
        image = dt.draw_result(image)
    cam.show(image)
    if cam.check_key() == 'esc': break

hamster.stop()
wait(100)
