from roboid import *
import roboidai as ai
import random

hamster = HamsterS()
cam = ai.Camera('usb0', flip='h')
detector = ai.BodyPose()

detector.load_model()

ARMS = ['left', 'right', 'both']

left_hand_y, right_hand_y, left_shoulder_y, right_shoulder_y = 0, 0, 0, 0

def control():
    score = 0
    while True:
        robot_arm = random.choice(ARMS)
        if robot_arm == 'left':
            hamster.rotate_left_wheel(90, 50)
            hamster.rotate_left_wheel(-90, 50)
        elif robot_arm == 'right':
            hamster.rotate_right_wheel(90, 50)
            hamster.rotate_right_wheel(-90, 50)
        else:
            hamster.rotate_wheels(90, 50)
            hamster.rotate_wheels(-90, 50)
        if left_hand_y < left_shoulder_y and right_hand_y < right_shoulder_y:
            my_arm = 'both'
        elif left_hand_y < left_shoulder_y:
            my_arm = 'left'
        elif right_hand_y < right_shoulder_y:
            my_arm = 'right'
        else:
            my_arm = 'none'
        print('robot:', robot_arm, 'person:', my_arm)
        if robot_arm == my_arm:
            score += 1
            hamster.leds('green')
            hamster.sound_until_done('good job')
        else:
            score -= 1
            hamster.leds('red')
            hamster.sound_until_done('siren')
        hamster.leds('off')
        print('score:', score)
        wait(20)

cam.count_down(3)
parallel(control)

while True:
    image = cam.read()
    if detector.detect(image):
        left_hand_y = detector.get_xy('left hand')[1]
        right_hand_y = detector.get_xy('right hand')[1]
        left_shoulder_y = detector.get_xy('left shoulder')[1]
        right_shoulder_y = detector.get_xy('right shoulder')[1]
        image = detector.draw_result(image)
    
    cam.show(image)
    if cam.check_key() == 'esc': break
