import roboidai as ai
from roboid import *

hamster = HamsterS()
cam = ai.Camera('usb0', flip='h')
detector = ai.BodyPose()

detector.load_model()

left_hand_y, right_hand_y, left_shoulder_y, right_shoulder_y = 0, 0, 0, 0

def control():
    while True:
        if left_hand_y < left_shoulder_y and right_hand_y < right_shoulder_y:
            print('양손')
            hamster.rotate_wheels(90, 50)
            hamster.rotate_wheels(-90, 50)
        elif left_hand_y < left_shoulder_y:
            print('왼손')
            hamster.rotate_left_wheel(90, 50)
            hamster.rotate_left_wheel(-90, 50)
        elif right_hand_y < right_shoulder_y:
            print('오른손')
            hamster.rotate_right_wheel(90, 50)
            hamster.rotate_right_wheel(-90, 50)
        else:
            print('내림')
        wait(20)

cam.count_down(3)
parallel(control)

while True:
    image = cam.read()
    if detector.detect(image):
        left_hand_y = detector.get_xy('left hand')[1]
        right_hand_y = detector.get_xy('right hand')[1]
        left_shoulder_y = detector.get_xy('left shoulder')[1]
        right_shoulder_y = detector.get_xy('right shoulder')[1]
        image = detector.draw_result(image)
    
    cam.show(image)
    if cam.check_key() == 'esc': break
