from roboid import *
import roboidai as ai
import random

hamster = HamsterS()
cam = ai.Camera('usb0', flip='h')
detector = ai.FaceDetector()

DIRECTIONS = ['left', 'right']

def show_result(robot_direction, my_direction):
    print('robot:', robot_direction, 'person:', my_direction)
    if robot_direction == 'left':
        hamster.turn_right(30)
    else:
        hamster.turn_left(30)
    
    if my_direction == robot_direction:
        hamster.leds('red')
        hamster.sound_until_done('siren')
    else:
        hamster.leds('green')
        hamster.sound_until_done('good job')
    
    if robot_direction == 'left':
        hamster.turn_left(30)
    else:
        hamster.turn_right(30)
    hamster.leds('off')

while True:
    hamster.sound('dibidibidip')
    robot_direction = random.choice(DIRECTIONS)
    my_direction = None
    
    cam.count_down(2)
    while True:
        image = cam.read()
        if detector.detect(image):
            left_eye = detector.get_xy('left eye')
            right_eye = detector.get_xy('right eye')
            nose = detector.get_xy('nose')
            
            left_dist = abs(left_eye[0] - nose[0])
            right_dist = abs(right_eye[0] - nose[0])
            diff = left_dist - right_dist
            if diff > 10:
                my_direction = 'right'
                break
            elif diff < -10:
                my_direction = 'left'
                break
        
        cam.show(image)
        cam.check_key()
    
    show_result(robot_direction, my_direction)
