import roboidai as ai
from roboid import *

hamster = HamsterS()
cam = ai.Camera('usb0', flip='h')
detector = ai.HandPose()
detector.load_model()
cam.count_down(3)
while True:
    image = cam.read()
    center = image.shape[1] // 2
    if detector.detect(image):
        if detector.get_area('right', 'hand') < 50000:
            left = 30
            right = 30
        else:
            left = -30
            right = -30
        x = detector.get_xy('right', 'palm')[0]
        if x > center + 50:
            left -= 10
            right += 10
        elif x < center - 50:
            left += 10
            right -= 10
        hamster.wheels(left, right)
        image = detector.draw_result(image)
    else:
        hamster.stop()
    cam.show(image)
    if cam.check_key() == 'esc': break
hamster.stop()
wait(500)
