from roboidai.lab.ko import Node
from roboidai.lab.ko import move_zoo

from roboid import *
hamster = HamsterS()

ANIMALS = ['새', '개', '코끼리', '얼룩말']

root = Node('새')
current = root

def print_intro():
    print()
    print('로봇을 출발지에 방향을 맞추어 올려 놓아 주세요.')
    print('동물을 새, 강아지, 코끼리, 얼룩말 중에서 하나 준비합니다.')

def ask_animal():
    while True:
        print('어떤 동물인가요? (1. 개, 2. 코끼리, 3. 얼룩말)')
        index = int(input())
        if index >= 1 and index <= 3:
            return ANIMALS[index]

def ask_replay():
    global current
    print('다시 시작할까요? [y/n]')
    if input() == 'y':
        current = root
        print_intro()
        return True
    else:
        return False

print_intro()
while True:
    if current.is_terminal():
        animal = current.get_key() # 답
        print(animal + '인 것 같은데 맞습니까? [y/n]')
        if input() == 'y':
            print('{} 집으로 이동합니다.'.format(animal))
            move_zoo(hamster, animal)
        else:
            new_animal = ask_animal()
            print('{}, {} 구분하기 위한 질문을 적어 주세요.'.format(animal, new_animal))
            print('질문은 y/n으로 대답할 수 있어야 합니다.')
            question = input()
            print('{}에 y인 동물은 1. {}, 2. {} 중에서 누구인가요?'.format(question, animal, new_animal))
            if input() == '1': yes_animal, no_animal = animal, new_animal
            else: yes_animal, no_animal = new_animal, animal
            current.set_key(question)
            current.add_left(yes_animal)
            current.add_right(no_animal)
            print('새로운 지식이 추가되었습니다.')
        if not ask_replay(): break
    else:
        print(current.get_key() + '[y/n]') # 질문
        is_yes = input() == 'y'
        if is_yes: child = current.get_left()
        else: child = current.get_right()
        if child is None:
            animal = ask_animal()
            if is_yes: current.add_left(animal)
            else: current.add_right(animal)
            print('새로운 지식이 추가되었습니다.')
            if not ask_replay(): break
        current = child
